package week04

object ZH extends App {
  /**
   * Írjunk függvényt, ami kiszámolja az input list lista elemeinek átlagát!
   * Üres listára az érték legyen Double.NaN.
   * Pl.
   * ha az input list = List(1.0, 4.0, 2.0, 8.0, 5.0, 4.0)
   * akkor az érték 4.0.
   *
   * Az erre vonatkozó teszteset pontértéke 1.
   */
  def atlag(list: List[Double]): Double = list.sum / list.length

  /**
   * Írjunk függvényt, ami 2 hosszú ablakban számol csúszóátlagot: minden két szomszédos cellának az átlagát számolja ki
   * (így az eredmény lista hossza eggyel rövidebb lesz, mint az eredetié)!
   * Legfeljebb 1 hosszú listára legyen az érték Nil.
   * Pl.
   * ha az input list = List(1.0, 4.0, 2.0, 8.0, 5.0, 4.0)
   * akkor az érték List(2.5, 3.0, 5.0, 6.5, 4.5).
   *
   * Az erre vonatkozó teszteset pontértéke 2.
   */
  def csuszoatlag2(list: List[Double]): List[Double] = list match {
    case Nil => Nil
    case _::tail => (list zip tail).map{ p => (p._1 + p._2)/2.0 }
  }

  /**
   * Írjunk függvényt, ami a list: List[Double] listában size hosszú ablakban számol csúszóátlagot!
   * Pl.
   * ha az input list = List(1.0, 4.0, 2.0, 8.0, 5.0, 4.0) és size = 3,
   * akkor az érték List( (1+4+2)/3, (4+2+8)/3, (2+8+5)/3, (8+5+4)/3 ) legyenek (kiszámítva persze az elemeket).
   *
   * Feltehetjük, hogy a lista hossza legalább size.
   *
   * Az erre vonatkozó teszteset pontértéke 3.
   */
  def csuszoatlagGeneral(list: List[Double], size: Int): List[Double] =
    list.sliding(size).toList.map(atlag)

  /**
   * Írjunk generic függvényt, ami visszaadja, hogy a list: List[T] lista eleje megegyezik-e a prefix: List[T] listával!
   * Pl.
   * ha list = List(1,4,2,8,5,7) és prefix = List(1,4),
   * akkor az érték true.
   * A prefix = Nil minden listának prefixe!
   *
   * Az erre vonatkozó teszteset pontértéke 2.
   */
  def testPrefix[T](list: List[T], prefix: List[T]): Boolean = (list,prefix) match {
    case (_,Nil) => true
    case (Nil,_) => false
    case (head::tail, prefixHead::prefixTail) if (head == prefixHead) => testPrefix(tail,prefixTail)
    case _ => false
  }

  /**
   * Írjunk generic függvényt, ami a haystack: List[T] listában keresi a needle: List[T] listát,
   * true-t ad vissza akkor, ha egybefüggő részlistája haystack-nek needle!
   * Pl.
   * ha haystack = List(1,4,2,8,5,7) és needle = (2,8,5)
   * akkor az érték true.
   * A needle = Nil minden listának egybefüggő részlistája!
   *
   * Az erre vonatkozó teszteset pontértéke 2.
   */
  def containsNeedle[T](haystack: List[T], needle: List[T]): Boolean = haystack match {
    case Nil => (needle==Nil)
    case _::tail => testPrefix(haystack, needle) || containsNeedle(tail, needle)
  }
}
