package week06

case class Mazsola(meret: Int)

object Eloadas extends App {
  val list = List( List(1,2), List(3,4), List(5,6) )
  println( list )  //prints List(List(1, 2), List(3, 4), List(5, 6))
  println( list.flatten ) //prints List(1, 2, 3, 4, 5, 6)

  val list2 = List( List(1,2), List( List(3,4), List(5,6) ), List(7,8) )
  println( list2.flatten ) //prints List(1, 2, List(3, 4), List(5, 6), 7, 8)

  val list3 = List( List(1,2), 3, List(4,5))
  //println( list3.flatten) //does not compile

  val vec = Vector() //üres vektor
  val vec2 = Vector(1,4,2,8,5,7) //hatelemű Vector[Int]
  println(vec2) //prints Vector(1, 4, 2, 8, 5, 7)
  //println(vec(0)) // java.lang.IndexOutOfBoundsException
  println(vec2(0)) //prints 1
  println(vec2(5))  //prints 7
  val vec3 = vec2.updated(1, 9)
  println(vec2) // prints Vector(1, 4, 2, 8, 5, 7)
  println(vec3) // prints Vector(1, 9, 2, 8, 5, 7)
  val vec4 = 0 +: vec3 :+ 10 //prepend, append
  println(vec4) // prints Vector(0, 1, 9, 2, 8, 5, 7, 10)

  println( vec4 map { _.toBinaryString } ) // prints Vector(0, 1, 1001, 10, 1000, 101, 111, 1010)
  println( vec4 filter { _%3 == 0 } ) // prints Vector(0, 9)
  println( vec4.foldLeft[Int](0){ (sum:Int,elem:Int) => sum+elem }) //prints 42
  println( vec3.flatMap{ x => Vector(x,x)} ) //prints Vector(1, 1, 9, 9, 2, 2, 8, 8, 5, 5, 7, 7)
  println( vec3.flatMap{ x => List(x,x)} )   //prints Vector(1, 1, 9, 9, 2, 2, 8, 8, 5, 5, 7, 7)
  println( List(1,2,3).flatMap{ x => Vector(x,x)}) //prints List(1, 1, 2, 2, 3, 3)

  def legnagyobb(mazsolasz: Vector[Option[Mazsola]]): Option[Mazsola] = {
    val actualMazsolas = for( mazsolaVagyNone <- mazsolasz;
         mazsola <- mazsolaVagyNone // !!!
         ) yield mazsola
    if ( actualMazsolas.isEmpty ) None
    else Some(actualMazsolas.reduce( (m1,m2) => if(m1.meret < m2.meret ) m2 else m1  ))
  }
  def legnagyobb2(mazsolasz: Vector[Option[Mazsola]]): Option[Mazsola] = {
    val actualMazsolas = mazsolasz.flatten
    if ( actualMazsolas.isEmpty ) None
    else Some(actualMazsolas.reduce( (m1,m2) => if(m1.meret < m2.meret ) m2 else m1  ))
  }
  def legnagyobb3(mazsolasz: Vector[Option[Mazsola]]): Option[Mazsola] =
    mazsolasz.foldLeft[Option[Mazsola]](None) {
      (om1,om2) => (om1,om2) match {
        case (None,_) => om2
        case (_,None) => om1
        case (Some(m1), Some(m2)) => if(m1.meret < m2.meret ) om2 else om1
      }
    }

  println( legnagyobb( Vector(None,None,Some(Mazsola(4)),None,Some(Mazsola(9)),Some(Mazsola(5)),None)))
  println( legnagyobb2( Vector(None,None,Some(Mazsola(4)),None,Some(Mazsola(9)),Some(Mazsola(5)),None)))
  println( legnagyobb3( Vector(None,None,Some(Mazsola(4)),None,Some(Mazsola(9)),Some(Mazsola(5)),None)))

  val counts: Map[Char,Int] = Map('a'->7, 'b'->8, 'c'->10, 'a'->9)
  println(counts) //prints Map(a -> 9, b -> 8, c -> 10) note: 'a' kulcs maradt az új
  println(counts.get('a')) //prints Some(9)
  println(counts.get('d')) //prints None
  println(counts('a')) //prints 9
  //println(counts('d')) //throws NoSuchElementException
  println(counts.getOrElse('a',0)) //prints 9
  println(counts.getOrElse('d',0)) //prints 0
  println(counts.contains('a')) //prints true
  println(counts.contains('d')) //prints false

  def freqs(text: String) = text.foldLeft[Map[Char,Int]](Map().withDefaultValue(0)) {
    (map,c) => map.updated(c,1+map(c))
  }
  println(freqs("dinnye szilva narancs")) // prints Map(e -> 1, s -> 2, n -> 4, y -> 1, a -> 3, i -> 2,   -> 2, v -> 1, l -> 1, c -> 1, r -> 1, z -> 1, d -> 1)

  def maradekok(ints: Vector[Int], mod: Int) = ints.groupBy( x => x % mod )
  println( maradekok(Vector(1,4,2,8,5,7),4)) // prints HashMap(0 -> Vector(4, 8), 1 -> Vector(1, 5), 2 -> Vector(2), 3 -> Vector(7))
  println( maradekok(Vector(1,4,2,8,5,7),3)) // prints HashMap(1 -> Vector(1, 4, 7), 2 -> Vector(2, 8, 5))
}
